/* SPDX-License-Identifier: GPL-3.0-or-later */

/*
 * Copyright 2023 Cobham Gaisler AB
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <drv/grspwrouter.h>
#include "priv.h"

void grspwrouter_isr_register(grspwrouter_dev *dev, uint32_t err_mask, uint32_t port_mask, grspwrouter_isr_func isr, void * arg)
{
    dev->isr = isr;
    dev->isr_arg = arg;
    REG_WRITE(&dev->regs->imask, err_mask);
    REG_WRITE(&dev->regs->ipmask, port_mask);
}
