/* SPDX-License-Identifier: GPL-3.0-or-later */

/*
 * Copyright 2023 Cobham Gaisler AB
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <drv/grspwrouter.h>
#include "priv.h"

void grspwrouter_pnp_set(grspwrouter_dev * dev, uint16_t vendor_id,
                         uint16_t product_id, uint32_t serial,
                         bool keep_instance_id)
{
    uint32_t pnpuvend = 0;
    uint32_t pnpusn = 0;

    GRSPWROUTER_PNPUVEND_VI_SET(pnpuvend, vendor_id);
    GRSPWROUTER_PNPUVEND_PI_SET(pnpuvend, product_id);
    REG_WRITE(&dev->regs->pnpuvend, pnpuvend);

    if (keep_instance_id) {
        pnpusn = REG_READ(&dev->regs->pnpusn);
        pnpusn |= (serial & ~0xf);
        REG_WRITE(&dev->regs->pnpusn, pnpusn);
    } else {
        REG_WRITE(&dev->regs->pnpusn, serial);
    }
}
