#define MASK(from, to) ((2 << (from - to)) - 1)
#define BITFIELD(from, to, reg) ((reg >> to) & MASK(from, to))
#define SETBITFIELD(from, to, reg, val) (reg = ((reg & ~(MASK(from, to) << to)) | ((val & MASK(from, to)) << to)))

#define GRSPWROUTER_PCTRL_RD_SET(reg, val) SETBITFIELD(31U, 24U, reg, val)
#define GRSPWROUTER_PCTRL_ST_SET(reg, val) SETBITFIELD(21U, 21U, reg, val)
#define GRSPWROUTER_PCTRL_AD_SET(reg, val) SETBITFIELD(19U, 19U, reg, val)
#define GRSPWROUTER_PCTRL_PL_SET(reg, val) SETBITFIELD(17U, 17U, reg, val)
#define GRSPWROUTER_PCTRL_TS_SET(reg, val) SETBITFIELD(16U, 16U, reg, val)
#define GRSPWROUTER_PCTRL_IC_SET(reg, val) SETBITFIELD(15U, 15U, reg, val)
#define GRSPWROUTER_PCTRL_ET_SET(reg, val) SETBITFIELD(14U, 14U, reg, val)
#define GRSPWROUTER_PCTRL_TR_SET(reg, val) SETBITFIELD(9U, 9U, reg, val)
#define GRSPWROUTER_PCTRL_TE_SET(reg, val) SETBITFIELD(5U, 5U, reg, val)
#define GRSPWROUTER_PCTRL_LS_SET(reg, val) SETBITFIELD(1U, 1U, reg, val)
#define GRSPWROUTER_PCTRL_LD_SET(reg, val) SETBITFIELD(0U, 0U, reg, val)
#define GRSPWROUTER_RTPMAP_PD_SET(reg, val) SETBITFIELD(0U, 0U, reg, val)
#define GRSPWROUTER_RTACTRL_SR_SET(reg, val) SETBITFIELD(3U, 3U, reg, val)
#define GRSPWROUTER_RTACTRL_EN_SET(reg, val) SETBITFIELD(2U, 2U, reg, val)
#define GRSPWROUTER_RTACTRL_PR_SET(reg, val) SETBITFIELD(1U, 1U, reg, val)
#define GRSPWROUTER_RTACTRL_HD_SET(reg, val) SETBITFIELD(0U, 0U, reg, val)
#define GRSPWROUTER_RTRCFG_SR(reg) BITFIELD(15U, 15U, reg)
#define GRSPWROUTER_RTRCFG_IC_SET(reg, val) SETBITFIELD(13U, 13U, reg, val)
#define GRSPWROUTER_RTRCFG_IE_SET(reg, val) SETBITFIELD(8U, 8U, reg, val)
#define GRSPWROUTER_RTRCFG_SP(reg) BITFIELD(31U, 27U, reg)
#define GRSPWROUTER_RTRCFG_AP(reg) BITFIELD(26U, 22U, reg)
#define GRSPWROUTER_PSTS_PT(reg) BITFIELD(31U, 30U, reg)
#define GRSPWROUTER_PSTS_LS(reg) BITFIELD(14U, 12U, reg)
#define GRSPWROUTER_PCTRL2_SM_SET(reg, val) SETBITFIELD(31U, 24U, reg, val)
#define GRSPWROUTER_PCTRL2_SV_SET(reg, val) SETBITFIELD(23U, 16U, reg, val)
#define GRSPWROUTER_PCTRL2_OR_SET(reg, val) SETBITFIELD(15U, 15U, reg, val)
#define GRSPWROUTER_PCTRL2_UR_SET(reg, val) SETBITFIELD(14U, 14U, reg, val)
#define GRSPWROUTER_PCTRL2_SD_SET(reg, val) SETBITFIELD(5U, 1U, reg, val)
#define GRSPWROUTER_PCTRL2_SC_SET(reg, val) SETBITFIELD(0U, 0U, reg, val)
#define GRSPWROUTER_TC_EN_SET(reg, val) SETBITFIELD(8U, 8U, reg, val)
#define GRSPWROUTER_TC_RE_SET(reg, val) SETBITFIELD(9U, 9U, reg, val)
#define GRSPWROUTER_TC_CF(reg) BITFIELD(7U, 6U, reg)
#define GRSPWROUTER_TC_TC(reg) BITFIELD(5U, 0U, reg)
#define GRSPWROUTER_CREDCNT_OC(reg) BITFIELD(11U, 6U, reg)
#define GRSPWROUTER_CREDCNT_IC(reg) BITFIELD(5U, 0U, reg)
#define GRSPWROUTER_PNPUVEND_VI_SET(reg, val) SETBITFIELD(31U, 16U, reg, val)
#define GRSPWROUTER_PNPUVEND_PI_SET(reg, val) SETBITFIELD(15U, 0U, reg, val)
#define GRSPWROUTER_MAPPEDADR_MA(reg) BITFIELD(7U, 0U, reg)

#ifdef GRSPWROUTER_TEST
uint32_t reg_read(volatile uint32_t * reg);
uint32_t reg_write(volatile uint32_t * reg, uint32_t val);
#define REG_READ(reg) (reg_read(reg))
#define REG_WRITE(reg, val) (reg_write(reg, val))
#else
#define REG_READ(reg) (*reg)
#define REG_WRITE(reg, val) (*reg = val)
#endif
