#include <stdint.h>

/**
 * @brief SpaceWire router register interface
 *
 * Details about the register interface can be found in the
 * GRLIB IP Core User’s Manual.
 *
 */
typedef struct grspwrouter_regs {
    volatile uint32_t rtpmap[256];
    volatile uint32_t rtactrl[256];
    volatile uint32_t pctrl[32];
    volatile uint32_t psts[32];
    volatile uint32_t ptimer[32];
    volatile uint32_t pctrl2[32];
    volatile uint32_t rtrcfg;
    volatile uint32_t tc;
    volatile uint32_t ver;
    volatile uint32_t idiv;
    volatile uint32_t cfgwe;
    volatile uint32_t prescaler;
    volatile uint32_t imask;
    volatile uint32_t ipmask;
    volatile uint32_t pip;
    volatile uint32_t icodegen;
    volatile uint32_t isr0;
    volatile uint32_t isr1;
    volatile uint32_t isrtimer;
    volatile uint32_t aitimer;
    volatile uint32_t isrctimer;
    volatile uint32_t resv0;
    volatile uint32_t lrunsts;
    volatile uint32_t cap;
    volatile uint32_t resv1;
    volatile uint32_t mappedadr;
    volatile uint32_t pnpvend;
    volatile uint32_t pnpuvend;
    volatile uint32_t pnpusn;
    volatile uint32_t resv2[0xe9];
    volatile uint32_t maxplen[32];
    volatile uint32_t credcnt[32];
    volatile uint32_t resv3[64];
    volatile uint32_t rtcomb[256];
} grspwrouter_regs;
